    processor 12f675
    include <p12f675.inc>
    __CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_ON & _MCLRE_OFF & _BODEN_ON & _CPD_OFF & _CP_OFF

#define PIN_ALARM GPIO,0
#define PIN_AUTOMATIK GPIO,2
#define PIN_STANDBY GPIO,1
#define PIN_START GPIO,5

    udata_shr
usleepcnt   	res 	1
usleepcnt2  	res 	1

STARTUP 		code
    clrf  PCLATH
    bcf STATUS,Z
    bcf STATUS,C
    bcf STATUS,DC
    call initPorts

mainloop
    bsf ADCON0,GO_DONE          ; Start A/D converter

waitalarm
    btfsc ADCON0,GO_DONE        ; A/D finished?
    goto waitalarm

    movf ADRESH,W
    sublw .150                  ; Trigger alarm on ca. 3 volts
    btfsc STATUS,C              ; note that this is reversed -
                                ; 0 means that borrow was used 
    goto mainloop

    btfsc PIN_STANDBY           ; For robustness
    goto mainloop

    btfss PIN_AUTOMATIK         ; For robustness
    goto mainloop

    call press_start            ; press start to initiate heating

waitautomatik
    btfsc PIN_AUTOMATIK         ; Wait for automatic light to come on
    goto waitautomatik

    call delay                  ; Give the machine some time to think

    btfss PIN_STANDBY           ; For robustness
    goto mainloop

    call delay                  ; More time for the poor machine

    call press_start            ; Press start to brew coffee

endloop goto endloop            ; Loop forever - must be reset by toggling power

press_start                     ; Draw the start button low for 200ms
    call delay
    bcf PIN_START
    call delay
    bsf PIN_START
    return

initPorts
    movlw 0x07
    movwf CMCON
    banksel TRISIO
    movlw B'00000111'       ; GP0-2 are input ports
    movwf TRISIO
    movlw B'00010001'       ; Speed = Fosc/8, GP0/AN0 is analog
    movwf ANSEL
    banksel GPIO
    movlw 0xFF          ; Initialize all outputs to 1
    movwf GPIO
    movlw B'00000001'       ; Turn on A/D circuitry, channel 0 (AN0)
    movwf ADCON0
    return

; 200 ms delay
delay
    movlw .200
    movwf usleepcnt2
    decf usleepcnt2,F
    movlw .100
    call usleep10
    decfsz usleepcnt2,F
    goto $-4
    return

; Sleeps W*10 microseconds
; W must be >= 2
usleep10
    movwf usleepcnt
    decf usleepcnt,F
    nop     ; 10 cycles == 10 usec (1 cycle == 4 oscillations)
    nop
    nop
    nop
    nop
    nop
    nop
    decfsz usleepcnt,F
    goto $-8
    return

	end
